class Treap {
  Treap *parent, *left, *right;
  int priority;
  bool goRight, goLeft;
  
  void rotateRight ();
  void rotateLeft ();

public:
  Treap ();

  virtual int compare (Treap *that) { return that - this; }
  virtual void pushDown () {}
  virtual void pullUp () {}
  
  Treap *getParent () { return parent; }
  Treap *getLeft () { return left; }
  Treap *getRight () { return right; }

  // Go up to root and apply pushDown back down to this node.
  void pushDownRoot ();

  // Apply pullUp from this up to root.
  void pullUpRoot ();

  // Insert new nodes to the right of this node.
  void setMin ();

  // Insert new nodes to the left of this node.
  void setMax ();

  // Undo effect of setMin or setMax.
  void clearMinMax ();

  // Insert node into this tree but do not rebalance, pushDown, or pullUp.
  void insert (Treap *node);

  // Locate previous and next node in tree if node were inserted.
  void locate (Treap *node, Treap *&prev, Treap *&next);

  // Rebalance this node in its tree, pushDown, pullUp.  Return the new root.
  Treap *rebalance ();

  // Remove this node from the Treap.  Return the new root.
  Treap *remove ();

  // Root of tree.
  Treap *root ();

  // First node in tree.
  Treap *first ();

  // Last node in tree.
  Treap *last ();

  // Next node in tree.
  Treap *next ();

  // Previous node in tree.
  Treap *prev ();

  // -1/0/1 if this is left/equal/right of that in tree.
  // Assumes no setMin or setMax active.
  int compareTree (Treap *that);
};

