#ifndef PLOT
#define PLOT

#include <GL/glut.h>
#include <vector>
#include "Point.h"

void graphics_init (int argc, char **argv, int wsize, Curves &br, Points &cr,
		    double *bb);

void reshape (int w, int h);

void keyboard (unsigned char key, int x, int y);

void mouse (int button, int buttonState, int x, int y);

Point point (int x, int y);

void mouse_zoom (int buttonState, const Point &p);

void motion (int x, int y);

void display ();

void display_zoom ();

void set_scale (double x1, double x2, double y1, double y2);

void clear_screen (float *color);

void draw_axes (const double *xr, const double *yr);

void draw_polyline (const Points &points);

void draw_point (const Point &p);

#endif
